<?php
/**
 * Created by PhpStorm.
 * User: jderosa
 * Date: 17/06/19
 * Time: 17.24
 */

namespace FiloBlu\Rma\Plugin;
use Magento\Framework\App\Config\ScopeConfigInterface;

class AddCustomCarrier
{

    protected $scopeConfig;
    const RMA_CUSTOM_CARRIER = 'filoblu_disablerma_section/rma_group/rma_option_carrier';

    /**
     * AddCustomCarrier constructor.
     * @param ScopeConfigInterface $scopeConfig
     */
    public function __construct(ScopeConfigInterface $scopeConfig)
    {
        $this->scopeConfig = $scopeConfig;
    }


    /**
     * @param \Magento\Rma\Block\Returns\View $subject
     * @param $result
     * @return mixed
     */
    public function afterGetCarriers(\Magento\Rma\Block\Returns\View $subject, $result)
    {
        if($this->scopeConfig->getValue(self::RMA_CUSTOM_CARRIER) ?? 0)
        {
            $carriers['custom'] = "Custom";
            $result = array_merge($carriers,$result);
        }
        return $result;
    }


    /**
     * @param \Magento\Rma\Block\Returns\View $subject
     * @param $result
     * @throws \Magento\Framework\Exception\LocalizedException
     */
    public function afterToHtml(\Magento\Rma\Block\Returns\View $subject, $result)
    {
        $template = $subject->getTemplate();
        if ($template === 'return/view.phtml' && $this->scopeConfig->getValue(self::RMA_CUSTOM_CARRIER) ?? 0) {
            $result = str_replace('data-mage-init=\'{"rmaTrackInfo"','data-mage-init=\'{"filoblurmaTrackInfo"',$result);
            $div = '<tr><td colspan="2"><div id="tracking_custom_carrier_text" style="display:none">Enter a Different Carrier</div> <input type="text" style="display:none" class="input-text" value="" name="tracking_custom_carrier" id="tracking_custom_carrier" data-validate="{required:false}"></td> </tr>';
            $toFind='<td class="col actions">
                                        <button type="button" class="action add" id="btn-add-track-number" title="Add"><span>Add</span></button>';
            $result = str_replace($toFind,$toFind.$div,$result);

        }
        return $result;
    }


}